﻿/*
# Apprendre à programmer en ActionScript 3
# A. Tasso
# Chapitre 9 : Les principes du concept objet 
# Projet Le mini site 
# Fichier : Forme.as
*/

package {
	import flash.display.*;
	import flash.events.*;
	public class Forme extends Sprite {
		// a. Définition des propriétés d'une Forme
		private var largeur, hauteur:Number;
		public var couleur:uint;
		public var numero:uint;
		public var nom:String;
		public var nombreElt:uint;

		// b. Définition des méthodes Forme(), afficher() 
		public function Forme( nnum:uint, nlar:Number, nhau:Number,  ncou:uint, nnom:String, nelt:uint, over:Boolean) {
			numero = nnum;
			largeur = nlar;
			hauteur = nhau;
			couleur = ncou;
			nom= nnom;
			nombreElt =  nelt;
			seDessiner();
			// Si le pramètre over vaut true, la zone affichée sera sensible au rollover de la souris
			// Les pages ne sont pas sensible au rollover, le paramètre over sera égal à false, lors de la création des objes de type Page
			if (over) {
				addEventListener(MouseEvent.MOUSE_OVER, surOver);
				addEventListener(MouseEvent.MOUSE_OUT, surOut);
			}
		}
        // Afficher une zone rectangulaire à l'aide des propriétés de la classe
		private function seDessiner():void {
			var tmp = new Sprite();
			tmp.graphics.beginFill(couleur);
			tmp.graphics.drawRect(0, 0, largeur, hauteur);
			tmp.graphics.endFill();
			addChild(tmp);
		}
		
		// L'intensité diminue et le curseur prend la forme d'une main
		function surOver(e:MouseEvent):void {
			var cible:Sprite = e.currentTarget  as Sprite;
			cible.alpha = 0.4;
			cible.buttonMode = true;
		}
		// L'opacité de l'objet revient à l'état initial
		function surOut(e:MouseEvent):void {
			var cible:Sprite = e.currentTarget  as Sprite;
			cible.alpha = 1;
		}

		public function sAfficher():void {
			trace("--------------------- Forme -----------------------------");
			trace("largeur = " +  largeur);
			trace("largeur = " +  hauteur);
			trace("couleur = " +  couleur);
			trace("nom     = " +  nom);
			trace("--------------------------------------------------------");
		}
	}// Fin de la classe Forme
}